# -*- coding: utf-8 -*-

import codecs
import googlemaps
import re
import scrapy

API_key= 'AIzaSyCVMO84F5-qadD3-5qAha1AOt65M-vERUo'
gmaps = googlemaps.Client(key=API_key)
# Usage: place = gmaps.geocode('[ADDRESS GOES HERE]')

class DouradosNewsSpider(scrapy.Spider):
    name = "douradosnews"

    allowed_domains = ["douradosnews.com.br"]
    start_urls = ["http://www.douradosnews.com.br"]
    download_delay = 2

    re_news_link = re.compile("http:\/\/www.douradosnews.com.br\/(noticias|policia|dourados)\/(?:(?!ultimas-noticias|cultura-lazer|politica|brasil|cidades|economia|internacional|ligado-na-redacao|esportes|(dourados|policia)\?))[\w-]+")
    re_next = re.compile("http:\/\/www.douradosnews.com.br\/(noticias|policia|dourados)\/?(ultimas\-noticias)?(\?p=)+[0-9]?[0-9]?")
    re_address = r"([Cc]ruzamento (da |entre a ))?([Rr]ua|^[Rr]\.?|Tr\.|[Tt]\.|[Tt]ravessa|^[Aa]v\.?|Avenida) [A-Z]\w{0,}([A-Za-uà-ú]?(( e [A-Z]\w+|( e a)?| de| da)?(( [A-Z]\w+)?){1,}){1,}){1,}( com a (Rua|R\.?|Tr\.|T\.|Travessa|Av\.|Avenida|) [A-Z]\w{0,}([A-Za-uà-ú]?(( e| de| da)?(( [A-Z]\w+)?){1,}){1,}){1,})?"

    causes = [u'acidente', u'assassinado', u'assassino', u'atirar', u'atropela', u'atropelo', u'batida', u'bateu', u'capotar',
              u'capotou', u'esfaqueado', u'esfaquear', u'estrangulada', u'estrangulado', u'estrangulamento', u'estrangular',
              u'estrangulou', u'estupra', u'estupro', u'facada', u'furta', u'furto', u'matar', u'matou', u'morre', u'morte',
              u'roubo', u'tiro'
            # TODO
            # .
            # .
            # .
            ]

    file_bairros = codecs.open('bairros_dourados.txt', 'r+', encoding='utf-8')
    bairros = file_bairros.readlines()
    file_bairros.close()

    def parse(self, response):
        anchors = response.xpath('//a/@href').extract()
        for link in anchors:
            keep_going = False
            can_yield = False
            current_link = response.urljoin(link)

            if self.re_news_link.match(current_link) and not self.re_next.match(current_link):
                for cause in self.causes:

                    if cause in current_link:

                        current_content = []

                        for p in response.xpath('/html/body/div[1]/div/div/div[5]/div/div[2]/div/div/div[7]//p').extract():
                            current_content.append(p)

                        if not current_content:
                            for p in response.xpath('/html/body/div[1]/div/div/div[5]/div/div[2]/div/div/div[8]//p').extract():
                                current_content.append(p)

                        current_date = response.xpath('/html/body/div[1]/div/div/div[5]/div/div[2]/div/div/div[1]/h6/text()').extract_first()

                        current_local = []
                        for bairro in self.bairros:
                            for content in current_content:
                                if bairro[:-1] in content:
                                    current_local.append(bairro)

                        if current_content and not current_local:
                            for content in current_content:
                                for text in re.finditer(self.re_address, content):
                                    current_local.append(text.group(0))

                        googlemaps_lat_lng = {}
                        if current_local:
                            for local in current_local:
                                search_local = local + ' dourados ms'
                                place = gmaps.geocode(search_local)
                                if place and place[0]['address_components'][1]['long_name'] == 'Dourados':
                                    can_yield = True
                                    googlemaps_lat_lng[local] = place[0]['geometry']['location']

                        if can_yield:
                            yield {
                                'link': current_link,
                                'local_lat_lng': googlemaps_lat_lng if googlemaps_lat_lng else None
                            }
                    keep_going = True

            if self.re_next.match(current_link) or self.re_news_link.match(current_link) and keep_going:
                yield scrapy.Request(current_link, callback=self.parse)
